precision mediump float;
varying highp vec2 textureCoordinate;

uniform sampler2D inputImageTexture;

//uniform lowp float gamma;
//uniform lowp float fractionalWidthOfPixel;
//uniform lowp float aspectRatio;
//uniform highp float dotScaling;
//uniform int smallDot;
//uniform int randomClr;
//const lowp float c = 0.05;//amout of blocks = c*iResolution.x

uniform lowp float iGlobalTime ;
uniform lowp float frameWidth ;
uniform lowp float frameHeight ;
uniform lowp float sliderValue ;    // Work on Distance .

uniform lowp float sliderValue2 ;
uniform lowp float sliderValue3 ;
uniform lowp float aspectRatio;


void main()
{
    
//      lowp vec2 iResolution = vec2(frameWidth, frameHeight);
//    lowp vec2 iResolution = vec2( frameHeight/frameWidth,1.0);
    
    lowp vec2 iResolution = vec2( 1.0,1.0);


    
      lowp vec2 uv = textureCoordinate.xy / iResolution.xy;
    
//      uv.t = 1.0 - uv.t;  // invert the Image
//        uv.y = 1.0 - uv.y;  // invert the Image

    
    lowp float x = uv.s;
    lowp float y = uv.t;
    
    
    // glitchStrength
    
//    lowp float glitchStrength = (100.0 + 55.55)/frameHeight * 5.0;
    lowp float glitchStrength = (100.0 + 55.55)/ 5.0;

    
//    glitchStrength = 0.2;
    
    glitchStrength = 30.0;
    
    glitchStrength = 21.0 - (sliderValue *20.0) ;  //10.0
    
//      lowp float glitchStrength = 1.0; //0.6

    
    // get snapped position
    lowp float psize = 0.04 * glitchStrength;
    lowp float psq = 1.0 / psize;
    
    lowp float px = floor( x * psq + 0.5) * psize;
    lowp float py = floor( y * psq + 0.5) * psize;
    
    lowp vec4 colSnap = texture2D( inputImageTexture, vec2( px,py) );
//    lowp vec4 colSnap = texture2D( inputImageTexture, vec2( textureCoordinate.x,textureCoordinate.y) );

//    gl_FragColor = colSnap ;

    
    lowp float lum = pow( 1.0 - (colSnap.r + colSnap.g + colSnap.b) / 3.0, glitchStrength );
    // remove the minus one if you want to invert luma

//    lum=10.04;
    
    
    // do move with lum as multiplying factor
//    lowp float qsize = psize * lum;
    
    lowp float qsize = 1.0 * lum;
    lowp float qsq = 1.0 / qsize;
    
    lowp float qx = floor( x * qsq + 0.5) * qsize;
    lowp float qy = floor( y * qsq + 0.5) * qsize;
    
    lowp float rx = (px - qx) * lum + x;
    lowp float ry = (py - qy) * lum + y;

//    lowp vec4 colMove = texture2D( inputImageTexture, vec2( rx,ry) );
    

    gl_FragColor = texture2D(inputImageTexture, vec2( rx,ry) );

//    gl_FragColor = texture2D(inputImageTexture, textureCoordinate );

    

    
    
    /*
     
     void mainImage( out vec4 fragColor, in vec2 fragCoord )
     {
     vec2 uv = fragCoord.xy / iResolution.xy;
     //    uv.t = 1.0 - uv.t;
     
     float x = uv.s;
     float y = uv.t;
     
     //
     // float glitchStrength = (iMouse.y + 55.55)/iResolution.y * 5.0;
     
     float glitchStrength = 1.01;
     
     
     // get snapped position
     float psize = 0.04 * glitchStrength;
     float psq = 1.0 / psize;
     
     float px = floor( x * psq + 0.5) * psize;
     float py = floor( y * psq + 0.5) * psize;
     
     vec4 colSnap = texture( iChannel0, vec2( px,py) );
     
     float lum = pow( 1.0 - (colSnap.r + colSnap.g + colSnap.b) / 3.0, glitchStrength ); // remove the minus one if you want to invert luma
     
     
     
     // do move with lum as multiplying factor
     float qsize = psize * lum;
     
     float qsq = 1.0 / qsize;
     
     float qx = floor( x * qsq + 0.5) * qsize;
     float qy = floor( y * qsq + 0.5) * qsize;
     
     float rx = (px - qx) * lum + x;
     float ry = (py - qy) * lum + y;
     
     //vec4 colMove = texture( iChannel0, vec2( rx,ry) );
    	vec4 colMove = texture( iChannel0, uv );
     
     
     // final color
     fragColor = colMove;
     }

     
     */
 
    
    
}






