precision highp float;
uniform sampler2D u_inputTexture;
uniform int mode;
varying vec2 v_texCoord;


const vec3 size = vec3(512,512,16);
const int Quality = 10;
const int Directions = 26;
const float Pi = 6.28318530718;//pi * 2
void main() {
    //simple pass\n" +

    vec2 radius = size.z/size.xy;
    vec4 Color = texture2D(u_inputTexture, v_texCoord);
    for( float d=0.0;d<Pi;d+=Pi/float(Directions) )
    {
        for( float i=1.0/float(Quality);i<=1.0;i+=1.0/float(Quality) )
        {
            Color += texture2D( u_inputTexture, v_texCoord+vec2(cos(d),sin(d))*radius*i);
        }
    }
    Color /= float(Quality)*float(Directions)+1.0;
    gl_FragColor = Color;
}