varying highp vec2 textureCoordinate;

uniform sampler2D inputImageTexture;

uniform lowp float sliderValue ;
uniform lowp float sliderValue2 ;
uniform lowp float sliderValue3 ;
uniform lowp float aspectRatio;

//lowp float sliderValue = 0.75;
//lowp float sliderValue2 = 0.75;
//lowp float sliderValue3 = 0.75;




uniform lowp float iGlobalTime ;
//uniform lowp float constant ;

uniform lowp float frameWidth ;
uniform lowp float frameHeight ;

void main()
{
 
    //-*-*
    lowp float fractionalWidthOfPixel = (sliderValue+0.01) /10.0;

    lowp float aspectRatioCal = aspectRatio;
    
    lowp float dotScaling  = (sliderValue2*0.6)+0.25;
    lowp float borderWidth = (sliderValue3*0.3)+0.7;
    
    //aspectRatioCal = 1.0 ;
    //aspectRatioCal = frameWidth /frameHeight ;
    //aspectRatioCal = frameHeight /frameWidth;
    
    
    ///-*-* new
    
    highp vec2 sampleDivisor = vec2(fractionalWidthOfPixel, fractionalWidthOfPixel / aspectRatioCal );
    highp vec2 samplePos = textureCoordinate - mod(textureCoordinate, sampleDivisor) + 0.5 * sampleDivisor;
    
    //gl_FragColor = texture2D(inputImageTexture, samplePos );
    //gl_FragColor = texture2D(inputImageTexture, textureCoordinate );
    //return;
    
    
    
    
    // The mod function returns x minus the product of y and floor(x/y)
    //  ** Floor  ==> 3.01 becomes 3.0
    
    highp vec2 textureCoordinateToUse = vec2(textureCoordinate.x, (textureCoordinate.y * aspectRatioCal + 0.5 - 0.5 * aspectRatioCal));
    
    highp vec2 adjustedSamplePos = vec2(samplePos.x, (samplePos.y * aspectRatioCal + 0.5 - 0.5 * aspectRatioCal));
    
    
    highp float distanceFromSamplePoint = distance(adjustedSamplePos, textureCoordinateToUse);  // Calculate Distance between two Points
    
    lowp vec4 inputColor = texture2D(inputImageTexture, samplePos);

    
    lowp float big = (fractionalWidthOfPixel * 0.5) * dotScaling;
    lowp float Small = (fractionalWidthOfPixel * 0.5) * (dotScaling-0.1);
//    lowp float border = (fractionalWidthOfPixel * 0.5) * (dotScaling + 0.2);
    
//    lowp float border = (fractionalWidthOfPixel * 0.9);
    lowp float border = (fractionalWidthOfPixel * borderWidth);

    
    //stud
    if(distanceFromSamplePoint<big && distanceFromSamplePoint>Small)
    {
        inputColor *= dot(vec2(0.707),normalize(textureCoordinateToUse-adjustedSamplePos))*.5+1.;
    }
    
    //side shadow
//    lowp vec2 delta = abs(textureCoordinateToUse-adjustedSamplePos)*c*2.0;
    
    lowp vec2 delta = abs(textureCoordinateToUse-adjustedSamplePos)*2.0;
    lowp float sdis = max(delta.x,delta.y);
    
    if(sdis > border)
    {
        inputColor *= 0.6;
    }
    
    gl_FragColor = inputColor;

    
    /*
    
//    //-*-* second Circle By Lakh
    // *
  //  highp vec2 textureCoordinateToUse2 = vec2(textureCoordinate.x, (textureCoordinate.y * (aspectRatio-0.1) + 0.5 - 0.5 * (aspectRatio-0.1)));
    
  //  highp vec2 adjustedSamplePos2 = vec2(samplePos.x, (samplePos.y * (aspectRatio-0.1) + 0.5 - 0.5 * (aspectRatio-0.1)));
    
   // highp float distanceFromSamplePoint2 = distance(adjustedSamplePos2, textureCoordinateToUse2);  // Calculate Distance between two Points
   //  * /
    
    
    //// small point Cirlce
    lowp float big = (fractionalWidthOfPixel * 0.5) * dotScaling;
    lowp float Small = (fractionalWidthOfPixel * 0.5) * (dotScaling-0.1);
    lowp float case1 = (fractionalWidthOfPixel * 0.5) * 0.33;
    lowp float case2 = (fractionalWidthOfPixel * 0.5) * 0.66;
    
    if ( distanceFromSamplePoint < case1  && smallDot ==1)
    {
        inputColor.r=inputColor.g;
        inputColor.g=inputColor.b;
        inputColor.b=inputColor.r;
    }
    
//    inputColor.a = distanceFromSamplePoint;
  
//    lowp float type2 = random(1000);
//    lowp float type2 = random(1000);
    
    lowp  float seed = textureCoordinate.x;
    
        inputColor.a = seed;
    
//    seed = (1103515245 * seed + 12345 );
    
//    seed = 1.0 - ((double)seed/(double)0x3fffffff);
    
//    seed = (1103515245 * seed + 12345 ) & 0x7fffffff;

    
    
//    type =
    

    //-*-* Random Color Change
    if (type==0)
    {
        inputColor.r=inputColor.r;
        inputColor.g=inputColor.g;
        inputColor.b=inputColor.b;

    }
    if (type==1) {
        
        inputColor.r=inputColor.g;
        inputColor.g=inputColor.b;
        inputColor.b=inputColor.r;

    }
    if (type==2) {
        
        inputColor.r=inputColor.b;
        inputColor.g=inputColor.r;
        inputColor.b=inputColor.g;
        
    }
    if (type==3) {
        
        inputColor.r=inputColor.r;
        inputColor.g=inputColor.b;
        inputColor.b=inputColor.g;
    }
    if (type==4) {
        
        inputColor.r=inputColor.b;
        inputColor.g=inputColor.g;
        inputColor.b=inputColor.r;
    }
    if (type==5) {
        
        inputColor.r=inputColor.g;
        inputColor.g=inputColor.r;
        inputColor.b=inputColor.b;
    }
    
    
    lowp float value;

    //// Black Circle Line
    if (big > distanceFromSamplePoint && Small < distanceFromSamplePoint )
    {
        value =0.0;
    }
    else
    {
        value =1.0;
    }
    inputColor.rgb = inputColor.rgb *  value;
    
           // gl_FragColor = vec4(inputColor.rgb * value, inputColor.a);
    gl_FragColor = vec4(inputColor.rgb , inputColor.a);
    
    /*
    lowp float checkForPresenceWithinDot = step(distanceFromSamplePoint, big);   // Conver 0 and 1  ==> Step ( , )
//
//    lowp float checkForPresenceWithinDot2 = step(distanceFromSamplePoint, Small);   // Conver 0 and 1  ==> Step ( , )


    
//    lowp vec4 circle=  vec4(inputColor.rgb * checkForPresenceWithinDot, inputColor.a);
    
     gl_FragColor = vec4(inputColor.rgb * checkForPresenceWithinDot, inputColor.a);
 */
    
    
//    gl_FragColor = mix(inputColor , circle, inputColor.a);

 
//    lowp vec4 c1 = texture2D(inputImageTexture, samplePos);
//    lowp vec4 c2=  vec4(inputColor.rgb * checkForPresenceWithinDot, inputColor.a);
//    
//    gl_FragColor = vec4(inputColor.rgb * checkForPresenceWithinDot, inputColor.a);
//

    
    
    
    //-*-* org
//    gl_FragColor = vec4(inputColor.rgb * checkForPresenceWithinDot, inputColor.a);
    
//    gl_FragColor = texture2D(inputImageTexture, samplePos );

}

//-*-*- half tone

//varying vec2 textureCoordinate;
//
//uniform sampler2D inputImageTexture;
//
//uniform float fractionalWidthOfPixel;
//uniform float aspectRatio;
//
//const vec3 W = vec3(0.2125, 0.7154, 0.0721);
//
//void main()
//{
//    vec2 sampleDivisor = vec2(fractionalWidthOfPixel, fractionalWidthOfPixel / aspectRatio);

//    vec2 samplePos = textureCoordinate - mod(textureCoordinate, sampleDivisor) + 0.5 * sampleDivisor;


//    vec2 textureCoordinateToUse = vec2(textureCoordinate.x, (textureCoordinate.y * aspectRatio + 0.5 - 0.5 * aspectRatio));

//    vec2 adjustedSamplePos = vec2(samplePos.x, (samplePos.y * aspectRatio + 0.5 - 0.5 * aspectRatio));

//    float distanceFromSamplePoint = distance(adjustedSamplePos, textureCoordinateToUse);

//    vec3 sampledColor = texture2D(inputImageTexture, samplePos ).rgb;
//    float dotScaling = 1.0 - dot(sampledColor, W);
//    
//    float checkForPresenceWithinDot = 1.0 - step(distanceFromSamplePoint, (fractionalWidthOfPixel * 0.5) * dotScaling);
//    
//    gl_FragColor = vec4(vec3(checkForPresenceWithinDot), 1.0);

//}





