
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform highp float iGlobalTime ;
uniform highp float constant ;

uniform highp float frameWidth ;
uniform highp float frameHeight ;

//const highp vec2 iMouse = vec2(0.5,0.5);   // Need Control
//const highp float speed = 1.0 ;   // Need Control


// Track the two best colors
highp vec3 dst0 = vec3(0), dst1 = vec3(0);
highp float best0 = 1e3, best1 = 1e3;

highp vec3 src;


highp float hash(highp vec2 p)
{
    return fract(1e4 * sin(17.0 * p.x + p.y * 0.1) * (0.1 + abs(sin(p.y * 13.0 + p.x))));
}


highp float compare(highp vec3 a,highp vec3 b)
{
    // Increase saturation
    a = max(vec3(0.0), a - min(a.r, min(a.g, a.b)) * 0.25);
    b = max(vec3(0.0), b - min(b.r, min(b.g, b.b)) * 0.25);
    a*=a*a;
    b*=b*b;
    highp vec3 diff = (a - b);
    return dot(diff, diff);
}



//highp vec3 TryJugad(highp vec3 clr)

void TryJugad(highp vec3 clr)
{
    
    /*const highp vec3 tst = highp vec3(R, G, B);
    highp float err = compare(src, tst);*/
   
    highp float err = compare(src, clr);

    if (err < best0)
    {
        best1 = best0;
        dst1 = dst0;
        best0 = err;
        dst0 = clr;
    }

    //return clr;
}





void main()
{
    highp vec2 U = textureCoordinate;
    highp vec2 iResolution = vec2(1.0,1.0);
    highp vec2 uv = textureCoordinate.xy / iResolution.xy;
    highp vec4 fragColor;
    
    const highp float pixelSize = 1.0;
    highp vec2 c = floor(textureCoordinate.xy / pixelSize);
    highp vec2 coord = c * pixelSize;
    src = texture2D(inputImageTexture , coord / iResolution.xy).rgb;
    
    
    /*
     
#	define TRY(R, G, B) { const highp vec3 tst = highp vec3(R, G, B); highp float err = compare(src, tst); if (err < best0) { best1 = best0; dst1 = dst0; best0 = err; dst0 = tst; } }
    
    TRY(0.078431, 0.047059, 0.109804);
    TRY(0.266667, 0.141176, 0.203922);
    TRY(0.188235, 0.203922, 0.427451);
    TRY(0.305882, 0.290196, 0.305882);
    TRY(0.521569, 0.298039, 0.188235);
    TRY(0.203922, 0.396078, 0.141176);
    TRY(0.815686, 0.274510, 0.282353);
    TRY(0.458824, 0.443137, 0.380392);
    TRY(0.349020, 0.490196, 0.807843);
    TRY(0.823529, 0.490196, 0.172549);
    TRY(0.521569, 0.584314, 0.631373);
    TRY(0.427451, 0.666667, 0.172549);
    TRY(0.823529, 0.666667, 0.600000);
    TRY(0.427451, 0.760784, 0.792157);
    TRY(0.854902, 0.831373, 0.368627);
    TRY(0.870588, 0.933333, 0.839216);
    
#	undef TRY
    
     */
    
    TryJugad(vec3(0.078431, 0.047059, 0.109804));
    TryJugad(vec3(0.266667, 0.141176, 0.203922));
    TryJugad(vec3(0.188235, 0.203922, 0.427451));
    TryJugad(vec3(0.305882, 0.290196, 0.305882));
    TryJugad(vec3(0.521569, 0.298039, 0.188235));
    TryJugad(vec3(0.203922, 0.396078, 0.141176));
    TryJugad(vec3(0.815686, 0.274510, 0.282353));
    TryJugad(vec3(0.458824, 0.443137, 0.380392));
    TryJugad(vec3(0.349020, 0.490196, 0.807843));
    TryJugad(vec3(0.823529, 0.490196, 0.172549));
    TryJugad(vec3(0.521569, 0.584314, 0.631373));
    TryJugad(vec3(0.427451, 0.666667, 0.172549));
    TryJugad(vec3(0.521569, 0.584314, 0.631373));
    TryJugad(vec3(0.427451, 0.666667, 0.172549));
    TryJugad(vec3(0.521569, 0.584314, 0.631373));
    TryJugad(vec3(0.427451, 0.666667, 0.172549));
    TryJugad(vec3(0.823529, 0.666667, 0.600000));
    TryJugad(vec3(0.427451, 0.760784, 0.792157));
    TryJugad(vec3(0.854902, 0.831373, 0.368627));
    TryJugad(vec3(0.870588, 0.933333, 0.839216));

    
//    highp vec3 TempA =  TryJugad(vec3(1.0, 1.0, 1.0));
    

    
    
//    best0 = sqrt(best0);
//    best1 = sqrt(best1);
    highp float time = (iGlobalTime/1000.0);
    fragColor = vec4(mod(c.x + c.y, 2.0) >  (hash(c * 2.0 + fract(sin(vec2(floor(time), floor(time * 1.7))))) * 0.75) + (best1 / (best0 + best1)) ? dst1 : dst0, 1.0);


    gl_FragColor = fragColor;
    
//    gl_FragColor =  texture2D(inputImageTexture, textureCoordinate);
    
}







