
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform highp float iGlobalTime ;

uniform highp float sliderValue;
uniform highp float frameWidth ;
uniform highp float frameHeight ;

const highp vec2 iMouse = vec2(0.5,0.5);   // Need Control
const highp float speed = 1.0 ;   // Need Control

highp float hash(highp vec2 p)
{
    highp float h = dot(p,vec2(127.1,311.7));
    return -1.0 + 2.0*fract(sin(h)*43758.5453123);
}

highp float noise(highp vec2 p)
{
    highp vec2 i = floor(p);
    highp vec2 f = fract(p);
    
    highp vec2 u = f*f*(3.0-2.0*f);
    
    return mix(mix(hash( i + vec2(0.0,0.0) ),
                   hash( i + vec2(1.0,0.0) ), u.x),
               mix( hash( i + vec2(0.0,1.0) ),
                   hash( i + vec2(1.0,1.0) ), u.x), u.y);
}

highp float noise(highp vec2 p, highp int oct)
{
    highp mat2 m = mat2( 1.6,  1.2, -1.2,  1.6 );
    highp float f  = 0.0;
    
    for(highp int i = 1; i < 3; i++){
        highp float mul = 1.0/pow(2.0, float(i));
        f += mul*noise(p); 
        p = m*p;
    }
    
    return f;
}



void main()
{
    highp vec2 U = textureCoordinate;
    highp vec2 iResolution = vec2(1.0,1.0);
    highp vec2 uv = textureCoordinate.xy / iResolution.xy;
    
    
    // highp vec2 uv = fragCoord.xy / iResolution.xy;
//    highp float time = iGlobalTime/1000.0;//mod(iGlobalTime/1000.0,10.0);
    highp float time = mod(iGlobalTime/1000.0,5.0);

    highp float glitch = pow(cos(time*0.5)*1.2+1.0, 1.2) * (sliderValue + 0.5);
    
    
    if(noise(time+vec2(0, 0))*glitch > 0.62)
    {
        uv.y = mod(uv.y+noise(vec2(time*4.0, 0)), 1.0);
    }
    
    
    highp vec2 hp = vec2(0.0, uv.y);
    
    highp float nh = noise(hp*7.0+time*10.0, 3) * (noise(hp+time*0.3)*0.8);
    nh += noise(hp*100.0+time*10.0, 3)*0.02;
    
    highp float rnd = 0.0;
    if(glitch > 0.0){
        rnd = hash(uv);
        if(glitch < 1.0){
            rnd *= glitch;
        }
    }
    nh *= glitch + rnd;
    highp float r = texture2D(inputImageTexture, uv+vec2(nh, 0.08)*nh).r;
    highp float g = texture2D(inputImageTexture, uv+vec2(nh-0.07, 0.0)*nh).g;
    highp float b = texture2D(inputImageTexture, uv+vec2(nh, 0.0)*nh).b;
    
    highp vec3 col = vec3(r, g, b);
//    fragColor = vec4(col.rgb, 1.0);
    
    gl_FragColor = vec4(col.rgb, 1.0);

    
//    gl_FragColor =  texture2D(inputImageTexture, textureCoordinate);
    
}

